## primesieve 6.3+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(primesieve)
set(PRIMESIEVE_VERSION "6.3")
set(PRIMESIEVE_SOVERSION "8.3.0")
set(CMAKE_BUILD_TYPE Release)

# Build options ######################################################

option(BUILD_PRIMESIEVE  "Build primesieve binary"    ON)
option(BUILD_SHARED_LIBS "Build shared libprimesieve" ON)
option(BUILD_STATIC_LIBS "Build static libprimesieve" ON)
option(BUILD_DOC         "Build documentation"        OFF)
option(BUILD_EXAMPLES    "Build example programs"     OFF)
option(BUILD_TESTS       "Build test programs"        OFF)

if(WIN32)
    set(BUILD_SHARED_LIBS OFF)
endif()

# Compiler must support C++11 or later ###############################

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# primesieve binary source files #####################################

set(BIN_SRC src/console/cmdoptions.cpp
            src/console/help.cpp
            src/console/main.cpp)

# primesieve library source files ####################################

set(LIB_SRC src/primesieve/api-c.cpp
            src/primesieve/api.cpp
            src/primesieve/CpuInfo.cpp
            src/primesieve/EratBig.cpp
            src/primesieve/EratMedium.cpp
            src/primesieve/EratSmall.cpp
            src/primesieve/iterator-c.cpp
            src/primesieve/iterator.cpp
            src/primesieve/nthPrime.cpp
            src/primesieve/ParallelPrimeSieve.cpp
            src/primesieve/popcount.cpp
            src/primesieve/PreSieve.cpp
            src/primesieve/PrimeGenerator.cpp
            src/primesieve/PrimeSieve.cpp
            src/primesieve/SieveOfEratosthenes.cpp
            src/primesieve/SievingPrimes.cpp
            src/primesieve/Wheel.cpp)

# Silence GCC switch fall through warnings ###########################

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wno-implicit-fallthrough no_fallthrough)

if(no_fallthrough)
    set_source_files_properties(src/primesieve/EratSmall.cpp PROPERTIES COMPILE_FLAGS -Wno-implicit-fallthrough)
endif()

# Check if libatomic is needed #######################################

include(CheckCXXSourceCompiles)

set(CMAKE_OLD_FLAGS ${CMAKE_REQUIRED_FLAGS})
set(CMAKE_REQUIRED_FLAGS ${CMAKE_CXX11_STANDARD_COMPILE_OPTION})

check_cxx_source_compiles("
    #include <atomic>
    int main() {
        std::atomic<int> x;
        x = 1;
        x--;
        return x;
    }"
    have_atomic)

set(CMAKE_REQUIRED_FLAGS ${CMAKE_OLD_FLAGS})

if(NOT have_atomic)
    find_library(ATOMIC NAMES atomic libatomic.so libatomic.so.1)
    if(ATOMIC)
        set(LIBATOMIC ${ATOMIC})
        message(STATUS "Found libatomic: TRUE")
    endif()
endif()

# libprimesieve ######################################################

add_library(libprimesieve ${LIB_SRC})
set_target_properties(libprimesieve PROPERTIES OUTPUT_NAME primesieve)
find_package(Threads REQUIRED)
target_link_libraries(libprimesieve Threads::Threads ${LIBATOMIC})

target_include_directories(libprimesieve PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

if(BUILD_SHARED_LIBS)
    string(REPLACE "." ";" SOVERSION_LIST ${PRIMESIEVE_SOVERSION})
    list(GET SOVERSION_LIST 0 PRIMESIEVE_SOVERSION_MAJOR)
    set_target_properties(libprimesieve PROPERTIES SOVERSION ${PRIMESIEVE_SOVERSION_MAJOR})
    set_target_properties(libprimesieve PROPERTIES VERSION ${PRIMESIEVE_SOVERSION})
endif()

install(TARGETS libprimesieve
        DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE})

# static_libprimesieve ###############################################

if(BUILD_STATIC_LIBS AND BUILD_SHARED_LIBS)
    add_library(static_libprimesieve STATIC ${LIB_SRC})
    set_target_properties(static_libprimesieve PROPERTIES OUTPUT_NAME primesieve)
    target_link_libraries(static_libprimesieve Threads::Threads ${LIBATOMIC})

    target_include_directories(static_libprimesieve PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    install(TARGETS static_libprimesieve
            DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE})
endif()

# primesieve binary ##################################################

if(BUILD_PRIMESIEVE)
    add_executable(primesieve ${BIN_SRC})
    target_link_libraries(primesieve libprimesieve)
    install(TARGETS primesieve
            DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
endif()

# Install headers ####################################################

install(FILES include/primesieve.h
              include/primesieve.hpp
              COMPONENT libprimesieve-headers
              DESTINATION ${CMAKE_INSTALL_PREFIX}/include)

install(FILES include/primesieve/PrimeSieve.hpp
              include/primesieve/StorePrimes.hpp
              include/primesieve/iterator.h
              include/primesieve/iterator.hpp
              include/primesieve/primesieve_error.hpp
              include/primesieve/pmath.hpp
              COMPONENT libprimesieve-headers
              DESTINATION ${CMAKE_INSTALL_PREFIX}/include/primesieve)

# Regenerate man page ################################################

if(BUILD_PRIMESIEVE)
    find_program(HELP2MAN help2man)
endif()

if(HELP2MAN)
    message(STATUS "Found help2man: ${HELP2MAN}")

    execute_process(COMMAND perl -e "use Locale::gettext;"
                    RESULT_VARIABLE LOCALE_RES
                    OUTPUT_QUIET ERROR_QUIET)

    if(LOCALE_RES EQUAL 0)
        message(STATUS "Found help2man option: --locale=C.UTF-8")
        set(HELP2MAN_LOCALE "--locale=C.UTF-8")
    endif()

    add_custom_command(
        TARGET ${PROJECT_NAME} POST_BUILD
        COMMAND ${HELP2MAN}
        ARGS -s 1
             --manual="primesieve"
             --source="primesieve ${PRIMESIEVE_VERSION}"
             --no-info
             ${HELP2MAN_LOCALE}
             -n "efficient prime number generator"
             -o ${PROJECT_SOURCE_DIR}/doc/primesieve.1
             ./primesieve
        VERBATIM)
endif()

# Install man page ###################################################

if(BUILD_PRIMESIEVE)
    install(FILES ${PROJECT_SOURCE_DIR}/doc/primesieve.1
            DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
endif()

# Install primesieve.pc (pkg-config) #################################

configure_file(primesieve.pc.in primesieve.pc @ONLY)

install(FILES ${CMAKE_BINARY_DIR}/primesieve.pc
        DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}/pkgconfig)

# Add subdirectories #################################################

if(BUILD_DOC)
    add_subdirectory(doc)
endif()

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()

=== doc/CMakeLists.txt ===
find_package(Doxygen)

if(DOXYGEN_FOUND)
    find_package(LATEX)
    if(LATEX_COMPILER)
        set(HAVE_LATEX "YES")
    else()
        set(HAVE_LATEX "NO")
    endif()

    find_program(DOT_FONUD dot)
    if(DOT_FONUD)
        message(STATUS "Found dot (graphviz): ${DOT_FONUD}")
        set(HAVE_DOT "YES")
    else()
        set(HAVE_DOT "NO")
    endif()

    configure_file(Doxyfile.in Doxyfile @ONLY)
    add_custom_target(doc COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile)

    if(LATEX_COMPILER)
        find_program(MAKE_FONUD make)

        # LaTeX doc (PDF) must be built using make
        if(MAKE_FONUD)
            add_custom_command(TARGET doc
                               POST_BUILD
                               COMMAND "${MAKE_FONUD}"
                               WORKING_DIRECTORY "latex")
        endif()
    endif()
endif()

=== test/CMakeLists.txt ===
file(GLOB files "*.cpp" "*.c")
foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_link_libraries(${binary_name} libprimesieve)
    add_test(NAME ${binary_name} COMMAND ${binary_name})
endforeach()

=== examples/c/CMakeLists.txt ===
file(GLOB files "*.c")
foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name}_c ${file})
    target_link_libraries(${binary_name}_c libprimesieve)
endforeach()

=== examples/cpp/CMakeLists.txt ===
file(GLOB files "*.cpp")
foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_link_libraries(${binary_name} libprimesieve)
endforeach()

## primesieve 5.6.0+ds

=== debian/changelog ===
primesieve (5.6.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Debianization:
    - debian/copyright:
      - Files-Excluded field, refine;
    - debian/control, upgrade SO version to version 6;
    - debian/libprimesieve5*, idem;
    - debian/rules, idem;
    - debian/clean, refresh;
    - debian/adhoc/Makefile, idem.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 19 Dec 2015 19:39:29 +0000

primesieve (5.5.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Debianization:
    - debian/rules, refresh;
    - debian/adhoc/Makefile, update.

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 09 Nov 2015 22:26:13 +0000

primesieve (5.5.0~rc1+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #802513)

 -- Jerome Benoit <calculus@rezozer.net>  Tue, 27 Oct 2015 21:00:34 +0000

=== debian/control ===
Source: primesieve
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jerome Benoit <calculus@rezozer.net>
Section: math
Priority: optional
Build-Depends: debhelper (>= 9), autotools-dev, dh-autoreconf, libtool, help2man
Build-Depends-Indep:
 doxygen, graphviz,
 texlive-latex-recommended, texlive-latex-extra, texlive-fonts-recommended,
 rdfind, symlinks
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/primesieve.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/primesieve.git
Homepage: http://primesieve.org/

Package: primesieve
Architecture: any
Depends: primesieve-bin, ${misc:Depends}
Description: fast prime number generator C/C++ library
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This dummy package provides the standard installation.

Package: libprimesieve6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: primesieve-bin (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libprimesieve
Provides: libprimesieve
Description: fast prime number generator C/C++ library -- lib
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the shared library.

Package: libprimesieve6-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libprimesieve6 (= ${binary:Version}), libprimesieve6-dev-common (= ${source:Version}),
 ${misc:Depends}
Suggests: pkg-config
Conflicts: libprimesieve-dev
Provides: libprimesieve-dev
Description: fast prime number generator C/C++ library -- libdev
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the static library and symbolic links needed
 for development.

Package: libprimesieve6-dev-common
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}
Recommends: libprimesieve6-dev (= ${binary:Version})
Provides: libprimesieve-dev-common
Description: fast prime number generator C/C++ library -- headers
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the headers needed by developers.

Package: primesieve-bin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast prime number generator C/C++ library -- bin
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the command line utility primesieve.

Package: libprimesieve6-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: libprimesieve6 (= ${binary:Version}), ${misc:Depends}
Conflicts: libprimesieve-dbg
Provides: libprimesieve-dbg
Description: fast prime number generator C/C++ library -- debug
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the debugging symbols.

Package: primesieve-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-jquery,
         ${misc:Depends}
Suggests: primesieve (= ${binary:Version}), pdf-viewer, www-browser
Description: fast prime number generator C/C++ library -- doc
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the API documentation with its concomitant examples.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_PKG_VERSION = $(shell dpkg-parsechangelog -S Version)

## inspired from mpfr material
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS    += -O0
	CXXCFLAGS += -O0
else ifeq ($(DEB_HOST_ARCH),alpha)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else ifeq ($(DEB_HOST_ARCH),sha4)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else
	CFLAGS   := $(subst -O2,-O3,$(CFLAGS))
	CXXFLAGS := $(subst -O2,-O3,$(CXXFLAGS))
endif

default:
	@uscan --no-conf --dehs --report || true

%:
	dh $@ --with autoreconf --builddirectory=_build --parallel

override_dh_auto_configure:
	dh_auto_configure -- --enable-maintainer-mode

override_dh_auto_build-indep: README.implementation
	$(MAKE) -f debian/adhoc/Makefile doc

override_dh_auto_test-indep:
	true

override_dh_prep-arch: README.implementation
	$(MAKE) -f debian/adhoc/Makefile manpages

override_dh_auto_install-indep:
	$(MAKE) -C _build install-data-am DESTDIR=$(CURDIR)/debian/tmp

override_dh_installdocs:
	dh_installdocs -pprimesieve-bin     --link-doc=libprimesieve6
	dh_installdocs -plibprimesieve6-dbg --link-doc=libprimesieve6
	dh_installdocs -plibprimesieve6-dev --link-doc=libprimesieve6-dev-common
	dh_installdocs --remaining-packages

override_dh_compress-indep:
	dh_compress -X.pdf -Xexamples

override_dh_strip:
	dh_strip --dbg-package=libprimesieve6-dbg

get-orig-source:
	uscan --no-conf --download-current-version --compression xz --verbose

README.implementation:
	cp -p src/primesieve/README README.implementation

=== debian/tests/control ===
Tests: make-check
Depends: primesieve-bin

Tests: build-examples
Depends: primesieve-doc, libprimesieve-dev, build-essential, pkg-config

=== debian/watch ===
version=3
opts=dversionmangle=s/\+ds//,uversionmangle=s/-rc/~rc/,repacksuffix=+ds,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/primesieve-$1\.tar\.gz/ \
https://github.com/kimwalisch/primesieve/releases .*/v?(\d\S*)\.tar\.gz

## primesieve 5.7.1+ds

=== debian/changelog ===
primesieve (5.7.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Debianization:
    - debian/copyright, refresh;
    - debian/patches/:
      - d/p/upstream-source-CPP2help2man.patch, reintroduce.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 18 Aug 2016 01:55:09 +0000

primesieve (5.7.0+ds-2) unstable; urgency=medium

  * RC bug fix release (Closes: #833870), harden libdev transition.

 -- Jerome Benoit <calculus@rezozer.net>  Wed, 10 Aug 2016 00:58:23 +0000

primesieve (5.7.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Debianization:
    - debian/watch:
      - bump to 4;
      - repack option, add;
    - debian/control:
      - upgrade SO version to version 7;
      - Suggests/Enhances fields, revisit;
    - debian/libprimesieve6*, bump to version 7;
    - debian/rules, refresh;
    - debian/adhoc/:
      - d/a/cpp/Makefile, harden;
    - refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 04 Aug 2016 15:00:58 +0000

primesieve (5.6.0+ds-2) unstable; urgency=medium

  * Debianization:
    - debian/copyright:
      - refresh;
    - debian/control:
      - discard the debug symbols package libbliss1d-dbg;
      - Standards Version, bump to 3.9.8 (no change);
      - Vcs-Git header, secure;
    - debian/rules:
      - discard the debug symbols material (see above);
      - dpkg-buildflags, add hardening=+all;
    - reproducible build, attempt.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 14 May 2016 14:34:00 +0000

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 export DEB_PKG_VERSION = $(shell dpkg-parsechangelog -S Version)
 
@@ -39,16 +41,12 @@
 	$(MAKE) -C _build install-data-am DESTDIR=$(CURDIR)/debian/tmp
 
 override_dh_installdocs:
-	dh_installdocs -pprimesieve-bin     --link-doc=libprimesieve6
-	dh_installdocs -plibprimesieve6-dbg --link-doc=libprimesieve6
-	dh_installdocs -plibprimesieve6-dev --link-doc=libprimesieve6-dev-common
+	dh_installdocs -pprimesieve-bin     --link-doc=libprimesieve7
+	dh_installdocs -plibprimesieve7-dev --link-doc=libprimesieve7-dev-common
 	dh_installdocs --remaining-packages
 
 override_dh_compress-indep:
 	dh_compress -X.pdf -Xexamples
-
-override_dh_strip:
-	dh_strip --dbg-package=libprimesieve6-dbg
 
 get-orig-source:
 	uscan --no-conf --download-current-version --compression xz --verbose

## primesieve 5.7.2+ds

=== debian/changelog ===
primesieve (5.7.2+ds-2) unstable; urgency=medium

  * RC bug fix release (Closes: #860664), neutralize the heavy test that
    challenges resources.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 22 Apr 2017 14:59:07 +0000

primesieve (5.7.2+ds-1) unstable; urgency=medium

  * New upstream release.
  * Debianization:
    - debian/copyright, update;
    - debian/rules, refresh;
    - debian/adhoc/Makefile, ad hoc manpage machinery, discard;
    - debian/patches/*:
      - d/p/upstream-source-CPP2help2man.patch, discard;
      - d/p/upstream-autotoolization-manpages.patch, introduce and submit;
      - d/p/debianization, refresh;
    - refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Tue, 15 Nov 2016 02:08:05 +0000

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,11 @@
 Priority: optional
 Build-Depends: debhelper (>= 9), autotools-dev, dh-autoreconf, libtool, help2man
 Build-Depends-Indep:
- doxygen, graphviz,
- texlive-latex-recommended, texlive-latex-extra, texlive-fonts-recommended,
+ doxygen, doxygen-latex, graphviz,
  rdfind, symlinks
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/primesieve.git
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/primesieve.git
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/primesieve.git
 Homepage: http://primesieve.org/
 
 Package: primesieve
@@ -25,7 +24,7 @@
  .
  This dummy package provides the standard installation.
 
-Package: libprimesieve6
+Package: libprimesieve7
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -43,14 +42,14 @@
  .
  This package provides the shared library.
 
-Package: libprimesieve6-dev
+Package: libprimesieve7-dev
 Architecture: any
 Multi-Arch: same
 Section: libdevel
 Depends:
- libprimesieve6 (= ${binary:Version}), libprimesieve6-dev-common (= ${source:Version}),
+ libprimesieve7 (= ${binary:Version}), libprimesieve7-dev-common (= ${source:Version}),
  ${misc:Depends}
-Suggests: pkg-config
+Suggests: primesieve-doc (= ${source:Version}), pkg-config
 Conflicts: libprimesieve-dev
 Provides: libprimesieve-dev
 Description: fast prime number generator C/C++ library -- libdev
@@ -63,12 +62,14 @@
  This package provides the static library and symbolic links needed
  for development.
 
-Package: libprimesieve6-dev-common
+Package: libprimesieve7-dev-common
 Architecture: all
 Multi-Arch: foreign
+Replaces: libprimesieve6-dev-common
+Breaks: libprimesieve6-dev-common
 Section: libdevel
 Depends: ${misc:Depends}
-Recommends: libprimesieve6-dev (= ${binary:Version})
+Recommends: libprimesieve7-dev (= ${binary:Version})
 Provides: libprimesieve-dev-common
 Description: fast prime number generator C/C++ library -- headers
  primesieve is a free software program and C/C++ library that generates
@@ -83,6 +84,7 @@
 Architecture: any
 Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Suggests: primesieve-doc (= ${source:Version})
 Description: fast prime number generator C/C++ library -- bin
  primesieve is a free software program and C/C++ library that generates
  primes using a highly optimized sieve of Eratosthenes implementation.
@@ -92,30 +94,13 @@
  .
  This package provides the command line utility primesieve.
 
-Package: libprimesieve6-dbg
-Architecture: any
-Multi-Arch: same
-Section: debug
-Priority: extra
-Depends: libprimesieve6 (= ${binary:Version}), ${misc:Depends}
-Conflicts: libprimesieve-dbg
-Provides: libprimesieve-dbg
-Description: fast prime number generator C/C++ library -- debug
- primesieve is a free software program and C/C++ library that generates
- primes using a highly optimized sieve of Eratosthenes implementation.
- primesieve can generate primes and prime k-tuplets up to nearly 2^64.
- .
- See http://primesieve.org/ for more information.
- .
- This package provides the debugging symbols.
-
 Package: primesieve-doc
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: libjs-jquery,
-         ${misc:Depends}
-Suggests: primesieve (= ${binary:Version}), pdf-viewer, www-browser
+Depends: libjs-jquery, ${misc:Depends}
+Suggests: pdf-viewer, www-browser
+Enhances: primesieve-bin (= ${binary:Version}), libprimesieve7-dev (= ${binary:Version})
 Description: fast prime number generator C/C++ library -- doc
  primesieve is a free software program and C/C++ library that generates
  primes using a highly optimized sieve of Eratosthenes implementation.

=== debian/rules ===
--- 
+++ 
@@ -35,7 +35,6 @@
 	true
 
 override_dh_prep-arch: README.implementation
-	$(MAKE) -f debian/adhoc/Makefile manpages
 
 override_dh_auto_install-indep:
 	$(MAKE) -C _build install-data-am DESTDIR=$(CURDIR)/debian/tmp

=== debian/watch ===
version=4
opts=repack,dversionmangle=s/\+ds//,uversionmangle=s/-rc/~rc/,repacksuffix=+ds,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/primesieve-$1\.tar\.gz/ \
https://github.com/kimwalisch/primesieve/releases .*/v?(\d\S*)\.tar\.gz

## primesieve 6.3%2Bds

=== debian/changelog ===
primesieve (6.3+ds-2ubuntu1) bionic; urgency=medium

  * Allow stderr output in autpkgtests to ignore
  * notes emitted by GCC7 on armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 26 Jan 2018 08:35:27 +0000

primesieve (6.3+ds-2) unstable; urgency=medium

  * Debianization:
    - debian/tests/*:
      - d/t/make-check[-bin], revisit (Closes: #884349),
        	thanks to upstream maintainer;
      - d/t/make-check-dev, introduce;
    - debian/copyright, refresh;
    - debian/control:
      - debhelper, bump to 11: (revisit d/primesieve-doc.docs);
        - d/primesieve-doc.docs, revisit;
        - d/t/build-examples, revisit;
        - d/adhoc/examples/c*/Makefile, revisit;
      - Standards Version, bump to 4.1.3 (no change);
    - refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 06 Jan 2018 12:50:07 +0000

primesieve (6.3+ds-1) unstable; urgency=medium

  * New upstream minor release (Closes: #881453, #881678).
  * Debianization:
    - debian/rules, simplify;
    - debian/patches/*:
      - d/p/upstream-fix-cmake_machinery-libatomic.patch, introduce.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 24 Nov 2017 13:51:00 +0000

primesieve (6.2+ds-1) unstable; urgency=medium

  * New upstream major release.
  * Debianization:
    - debian/watch, correct;
    - debian/copyright, update;
    - debian/control:
      - debhelper, bump to 10;
      - Standards Version, bump to 4.1.1 (no change);
      - upgrade SO version to version 8;
    - debian/rules:
      - migrate from autotools to cmake machinery (see below);
      - debhelper, bump to 10;
      - refresh;
    - debian/patches/*:
      - d/p/upstream-autotoolization-manpages.patch, discard;
      - d/p/debianization*.patch, discard;
      - d/p/upstream-cmake-install-*.patch, introduce and submit;
    - debian/libprimesieve7.*, bump to version 8;
    - debian/libprimesieve7-dev*.*, bump to versionless;
    - migration from autotools to cmake machinery;
    - refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 11 Nov 2017 05:56:10 +0000

## primesieve 6.3+ds

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,16 @@
 Source: primesieve
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
-Build-Depends: debhelper (>= 9), autotools-dev, dh-autoreconf, libtool, help2man
+Build-Depends:
+ debhelper (>= 11),
+ cmake, help2man
 Build-Depends-Indep:
  doxygen, doxygen-latex, graphviz,
  rdfind, symlinks
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/primesieve.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/primesieve.git
 Homepage: http://primesieve.org/
@@ -24,7 +27,7 @@
  .
  This dummy package provides the standard installation.
 
-Package: libprimesieve7
+Package: libprimesieve8
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -42,12 +45,12 @@
  .
  This package provides the shared library.
 
-Package: libprimesieve7-dev
+Package: libprimesieve-dev
 Architecture: any
 Multi-Arch: same
 Section: libdevel
 Depends:
- libprimesieve7 (= ${binary:Version}), libprimesieve7-dev-common (= ${source:Version}),
+ libprimesieve8 (= ${binary:Version}), libprimesieve-dev-common (= ${source:Version}),
  ${misc:Depends}
 Suggests: primesieve-doc (= ${source:Version}), pkg-config
 Conflicts: libprimesieve-dev
@@ -62,14 +65,14 @@
  This package provides the static library and symbolic links needed
  for development.
 
-Package: libprimesieve7-dev-common
+Package: libprimesieve-dev-common
 Architecture: all
 Multi-Arch: foreign
-Replaces: libprimesieve6-dev-common
-Breaks: libprimesieve6-dev-common
+Replaces: libprimesieve7-dev-common
+Breaks: libprimesieve7-dev-common
 Section: libdevel
 Depends: ${misc:Depends}
-Recommends: libprimesieve7-dev (= ${binary:Version})
+Recommends: libprimesieve-dev (= ${binary:Version})
 Provides: libprimesieve-dev-common
 Description: fast prime number generator C/C++ library -- headers
  primesieve is a free software program and C/C++ library that generates
@@ -100,7 +103,7 @@
 Section: doc
 Depends: libjs-jquery, ${misc:Depends}
 Suggests: pdf-viewer, www-browser
-Enhances: primesieve-bin (= ${binary:Version}), libprimesieve7-dev (= ${binary:Version})
+Enhances: primesieve-bin (= ${binary:Version}), libprimesieve-dev (= ${binary:Version})
 Description: fast prime number generator C/C++ library -- doc
  primesieve is a free software program and C/C++ library that generates
  primes using a highly optimized sieve of Eratosthenes implementation.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

## inspired from mpfr material
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS    += -O0
	CXXCFLAGS += -O0
else ifeq ($(DEB_HOST_ARCH),alpha)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else ifeq ($(DEB_HOST_ARCH),sha4)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else
	CFLAGS   := $(subst -O2,-O3,$(CFLAGS))
	CXXFLAGS := $(subst -O2,-O3,$(CXXFLAGS))
endif

default:
	@uscan --no-conf --dehs --report || true

%:
	dh $@ --builddirectory=_build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_TESTS=ON \
		-DBUILD_EXAMPLES=ON \
		-DBUILD_DOC=ON

override_dh_auto_build-indep: README.implementation
	$(MAKE) -f debian/adhoc/Makefile doc

override_dh_auto_test-indep:
	true

override_dh_prep-arch: README.implementation

override_dh_auto_install-indep:
	DESTDIR=$(CURDIR)/debian/tmp $(CMAKE) \
			-DCMAKE_INSTALL_COMPONENT=libprimesieve-headers \
		-P _build/cmake_install.cmake

override_dh_installdocs:
	dh_installdocs -pprimesieve-bin    --link-doc=libprimesieve8
	dh_installdocs -plibprimesieve-dev --doc-main-package=libprimesieve-dev-common
	dh_installdocs --remaining-packages

override_dh_installexamples-indep:
	dh_installexamples -XCMakeLists.txt -XREADME.md

override_dh_compress-indep:
	dh_compress -X.pdf -Xexamples

get-orig-source:
	uscan --no-conf --download-current-version --verbose

README.implementation:
	cp -p src/primesieve/README README.implementation

CMAKE ?= cmake

=== debian/tests/control ===
Tests: make-check-bin
Depends: primesieve-bin

Tests: make-check-dev
Depends: libprimesieve-dev, build-essential, pkg-config
Restrictions: allow-stderr

Tests: build-examples
Depends: primesieve-doc, libprimesieve-dev, build-essential, pkg-config

## primesieve 7.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(primesieve CXX)
set(PRIMESIEVE_VERSION "7.0")
set(PRIMESIEVE_SOVERSION "9.0.0")

# Build options ######################################################

option(BUILD_PRIMESIEVE  "Build primesieve binary"    ON)
option(BUILD_SHARED_LIBS "Build shared libprimesieve" ON)
option(BUILD_STATIC_LIBS "Build static libprimesieve" ON)
option(BUILD_DOC         "Build documentation"        OFF)
option(BUILD_EXAMPLES    "Build example programs"     OFF)
option(BUILD_TESTS       "Build test programs"        OFF)

if(WIN32)
    set(BUILD_SHARED_LIBS OFF)
endif()

if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
    message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON")
endif()

# primesieve binary source files #####################################

set(BIN_SRC src/console/cmdoptions.cpp
            src/console/help.cpp
            src/console/main.cpp)

# primesieve library source files ####################################

set(LIB_SRC src/api-c.cpp
            src/api.cpp
            src/CpuInfo.cpp
            src/EratBig.cpp
            src/EratMedium.cpp
            src/EratSmall.cpp
            src/iterator-c.cpp
            src/iterator.cpp
            src/IteratorHelper.cpp
            src/PrimeGenerator.cpp
            src/nthPrime.cpp
            src/ParallelSieve.cpp
            src/popcount.cpp
            src/PreSieve.cpp
            src/PrintPrimes.cpp
            src/PrimeSieve.cpp
            src/Erat.cpp
            src/SievingPrimes.cpp
            src/Wheel.cpp)

# Required includes ##################################################

include(GNUInstallDirs)
include(CMakePushCheckState)
include(CheckCXXCompilerFlag)
include(CheckCXXSourceCompiles)
include(CMakePackageConfigHelpers)

# Set default build type to Release ##################################

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()

# Silence GCC switch fall through warnings ###########################

check_cxx_compiler_flag(-Wno-implicit-fallthrough Wno_fallthrough)

if(Wno_fallthrough)
    set_source_files_properties(src/EratSmall.cpp PROPERTIES COMPILE_FLAGS -Wno-implicit-fallthrough)
endif()

# Check if libatomic is needed #######################################

cmake_push_check_state()

if(CMAKE_CXX11_STANDARD_COMPILE_OPTION)
    set(CMAKE_REQUIRED_FLAGS ${CMAKE_CXX11_STANDARD_COMPILE_OPTION})
endif()

check_cxx_source_compiles("
    #include <atomic>
    #include <stdint.h>
    int main() {
        std::atomic<int64_t> x;
        x = 1;
        x--;
        return (int) x;
    }"
    atomic64)

if(NOT atomic64)
    find_library(ATOMIC NAMES atomic libatomic.so.1)

    if(ATOMIC)
        set(LIBATOMIC ${ATOMIC})
        message(STATUS "Found libatomic: ${LIBATOMIC}")
    else()
        check_cxx_source_compiles("
            #include <atomic>
            #include <stdint.h>
            int main() {
                std::atomic<int32_t> x;
                x = 1;
                x--;
                return (int) x;
            }"
            atomic32)

        if(atomic32)
            message(FATAL_ERROR "Failed to find libatomic!")
        endif()
    endif()
endif()

cmake_pop_check_state()

# libprimesieve (shared library) #####################################

find_package(Threads REQUIRED QUIET)

if(BUILD_SHARED_LIBS)
    add_library(libprimesieve SHARED ${LIB_SRC})
    add_library(primesieve::primesieve ALIAS libprimesieve)
    set_target_properties(libprimesieve PROPERTIES OUTPUT_NAME primesieve)
    target_link_libraries(libprimesieve PRIVATE Threads::Threads ${LIBATOMIC})

    string(REPLACE "." ";" SOVERSION_LIST ${PRIMESIEVE_SOVERSION})
    list(GET SOVERSION_LIST 0 PRIMESIEVE_SOVERSION_MAJOR)
    set_target_properties(libprimesieve PROPERTIES SOVERSION ${PRIMESIEVE_SOVERSION_MAJOR})
    set_target_properties(libprimesieve PROPERTIES VERSION ${PRIMESIEVE_SOVERSION})

    target_compile_features(libprimesieve
    PUBLIC
        cxx_alias_templates
    PRIVATE
        cxx_constexpr
        cxx_uniform_initialization
        cxx_lambdas)

    target_include_directories(libprimesieve PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    install(TARGETS libprimesieve
            EXPORT primesieveShared
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# libprimesieve-static ###############################################

if(BUILD_STATIC_LIBS)
    add_library(libprimesieve-static STATIC ${LIB_SRC})
    set_target_properties(libprimesieve-static PROPERTIES OUTPUT_NAME primesieve)
    target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${LIBATOMIC})

    if(BUILD_SHARED_LIBS)
        add_dependencies(libprimesieve-static libprimesieve)
    else()
        add_library(primesieve::primesieve ALIAS libprimesieve-static)
    endif()

    target_compile_features(libprimesieve-static
    PUBLIC
        cxx_alias_templates
    PRIVATE
        cxx_constexpr
        cxx_uniform_initialization
        cxx_lambdas)

    target_include_directories(libprimesieve-static PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    install(TARGETS libprimesieve-static
            EXPORT primesieveStatic
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# primesieve binary ##################################################

if(BUILD_PRIMESIEVE)
    add_executable(primesieve ${BIN_SRC})
    target_link_libraries(primesieve primesieve::primesieve)
    target_compile_features(primesieve PRIVATE cxx_auto_type)
    install(TARGETS primesieve DESTINATION ${CMAKE_INSTALL_BINDIR})

    if(BUILD_STATIC_LIBS)
        add_dependencies(primesieve libprimesieve-static)
    endif()
endif()

# Install headers ####################################################

install(FILES include/primesieve.h
              include/primesieve.hpp
              COMPONENT libprimesieve-headers
              DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(FILES include/primesieve/iterator.h
              include/primesieve/iterator.hpp
              include/primesieve/StorePrimes.hpp
              include/primesieve/primesieve_error.hpp
              COMPONENT libprimesieve-headers
              DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/primesieve)

# CMake find_package(primesieve) support #############################

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfigVersion.cmake"
    VERSION ${PRIMESIEVE_VERSION}
    COMPATIBILITY SameMajorVersion)

configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/primesieveConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfig.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfig.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")

if(BUILD_SHARED_LIBS)
    install(EXPORT primesieveShared
            NAMESPACE primesieve::
            DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")
endif()

if(BUILD_STATIC_LIBS)
    install(EXPORT primesieveStatic
            NAMESPACE primesieve::
            DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")
endif()

# Regenerate man page ################################################

if(BUILD_PRIMESIEVE)
    find_program(HELP2MAN help2man)
endif()

if(HELP2MAN)
    message(STATUS "Found help2man: ${HELP2MAN}")

    execute_process(COMMAND perl -e "use Locale::gettext;"
                    RESULT_VARIABLE LOCALE_RES
                    OUTPUT_QUIET ERROR_QUIET)

    if(LOCALE_RES EQUAL 0)
        message(STATUS "Found help2man option: --locale=C.UTF-8")
        set(HELP2MAN_LOCALE "--locale=C.UTF-8")
    endif()

    add_custom_command(
        TARGET ${PROJECT_NAME} POST_BUILD
        COMMAND ${HELP2MAN}
        ARGS -s 1
             --manual="primesieve"
             --source="primesieve ${PRIMESIEVE_VERSION}"
             --no-info
             ${HELP2MAN_LOCALE}
             -n "efficient prime number generator"
             -o ${PROJECT_SOURCE_DIR}/doc/primesieve.1
             ./primesieve
        VERBATIM)
endif()

# Install man page ###################################################

if(BUILD_PRIMESIEVE)
    install(FILES ${PROJECT_SOURCE_DIR}/doc/primesieve.1
            DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
endif()

# Install primesieve.pc (pkg-config) #################################

configure_file(primesieve.pc.in primesieve.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/primesieve.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# Add subdirectories #################################################

if(BUILD_DOC)
    add_subdirectory(doc)
endif()

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()

=== test/CMakeLists.txt ===
enable_language(C)
file(GLOB files "*.cpp" "*.c")

foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_link_libraries(${binary_name} primesieve::primesieve Threads::Threads ${LIBATOMIC})
    add_test(NAME ${binary_name} COMMAND ${binary_name})
endforeach()

=== debian/changelog ===
primesieve (7.0+ds-3ubuntu1) cosmic; urgency=medium

  * Allow stderr output in autopkgtests for GCC warnings on armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 18 Jun 2018 14:36:25 +0000

primesieve (7.0+ds-3) unstable; urgency=medium

  * RC bug fix release (Closes: #901128), bump library so-suffix.
  * autopkgtests bug fix post-release (Closes: #901098).
  * Debianization:
    - debian/{control,rules}:
      - library so-suffix, bump to 9.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 09 Jun 2018 07:08:21 +0000

primesieve (7.0+ds-2) unstable; urgency=medium

  * autopkgtests bug fix release.
  * Debianization:
    - debian/tests/*:
      - d/t/make-check-dev , refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 09 Jun 2018 06:06:25 +0000

primesieve (7.0+ds-1) unstable; urgency=medium

  * New upstream major release.
  * Debianization:
   - debian/copyright:
      - Format field, secure URI;
    - debian/control:
      - Standards Version, bump to 4.1.4 (no change);
      - Homepage field, secure URI;
      - Vcs-* fields, migration to Salsa;
    - debian/source:
      - d/s/lintian-overrides , update;
    - debian/rules:
      - get-orig-source target, discard;
      - README.implementation.md target, refresh (cascade change);
    - debian/patches:
      - d/p/upstream-fix-cmake_machinery-libatomic.patch , integrated.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 08 Jun 2018 09:28:07 +0000

=== debian/control ===
--- 
+++ 
@@ -10,10 +10,10 @@
 Build-Depends-Indep:
  doxygen, doxygen-latex, graphviz,
  rdfind, symlinks
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/primesieve.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/primesieve.git
-Homepage: http://primesieve.org/
+Standards-Version: 4.1.4
+Vcs-Git: https://salsa.debian.org/science-team/primesieve.git
+Vcs-Browser: https://salsa.debian.org/science-team/primesieve
+Homepage: https://primesieve.org/
 
 Package: primesieve
 Architecture: any
@@ -27,7 +27,7 @@
  .
  This dummy package provides the standard installation.
 
-Package: libprimesieve8
+Package: libprimesieve9
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -50,7 +50,7 @@
 Multi-Arch: same
 Section: libdevel
 Depends:
- libprimesieve8 (= ${binary:Version}), libprimesieve-dev-common (= ${source:Version}),
+ libprimesieve9 (= ${binary:Version}), libprimesieve-dev-common (= ${source:Version}),
  ${misc:Depends}
 Suggests: primesieve-doc (= ${source:Version}), pkg-config
 Conflicts: libprimesieve-dev

## primesieve 7.3%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,8 @@
 cmake_minimum_required(VERSION 3.4)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "7.0")
-set(PRIMESIEVE_SOVERSION "9.0.0")
+set(PRIMESIEVE_VERSION "7.3")
+set(PRIMESIEVE_SOVERSION "9.3.0")
+set(CMAKE_BUILD_TYPE Release)
 
 # Build options ######################################################
 
@@ -11,10 +12,6 @@
 option(BUILD_DOC         "Build documentation"        OFF)
 option(BUILD_EXAMPLES    "Build example programs"     OFF)
 option(BUILD_TESTS       "Build test programs"        OFF)
-
-if(WIN32)
-    set(BUILD_SHARED_LIBS OFF)
-endif()
 
 if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
     message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON")
@@ -37,6 +34,7 @@
             src/iterator-c.cpp
             src/iterator.cpp
             src/IteratorHelper.cpp
+            src/MemoryPool.cpp
             src/PrimeGenerator.cpp
             src/nthPrime.cpp
             src/ParallelSieve.cpp
@@ -56,12 +54,14 @@
 include(CheckCXXSourceCompiles)
 include(CMakePackageConfigHelpers)
 
-# Set default build type to Release ##################################
-
-if(NOT CMAKE_BUILD_TYPE)
-    set(CMAKE_BUILD_TYPE "Release" CACHE STRING
-        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
-        FORCE)
+# MSVC DLL support (Windows) #########################################
+
+if(WIN32 AND NOT MINGW)
+    set(WIN32_MSVC_COMPATIBLE ON)
+    if(BUILD_SHARED_LIBS)
+        # Export symbols to .def file
+        set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
+    endif()
 endif()
 
 # Silence GCC switch fall through warnings ###########################
@@ -70,6 +70,7 @@
 
 if(Wno_fallthrough)
     set_source_files_properties(src/EratSmall.cpp PROPERTIES COMPILE_FLAGS -Wno-implicit-fallthrough)
+    set_source_files_properties(src/EratMedium.cpp PROPERTIES COMPILE_FLAGS -Wno-implicit-fallthrough)
 endif()
 
 # Check if libatomic is needed #######################################
@@ -123,14 +124,22 @@
 
 if(BUILD_SHARED_LIBS)
     add_library(libprimesieve SHARED ${LIB_SRC})
-    add_library(primesieve::primesieve ALIAS libprimesieve)
     set_target_properties(libprimesieve PROPERTIES OUTPUT_NAME primesieve)
     target_link_libraries(libprimesieve PRIVATE Threads::Threads ${LIBATOMIC})
-
     string(REPLACE "." ";" SOVERSION_LIST ${PRIMESIEVE_SOVERSION})
     list(GET SOVERSION_LIST 0 PRIMESIEVE_SOVERSION_MAJOR)
     set_target_properties(libprimesieve PROPERTIES SOVERSION ${PRIMESIEVE_SOVERSION_MAJOR})
     set_target_properties(libprimesieve PROPERTIES VERSION ${PRIMESIEVE_SOVERSION})
+
+    if(WIN32_MSVC_COMPATIBLE)
+        # On Windows the shared library will be named primesieve.dll
+        # and the associated import library will be named
+        # primesieve.lib. This is an issue as the static library
+        # is also named primesieve.lib. Hence we rename the import
+        # library to primesieve.dll.lib. The Rust programming
+        # language uses the same naming convention.
+        set_target_properties(libprimesieve PROPERTIES IMPORT_SUFFIX ".dll.lib")
+    endif()
 
     target_compile_features(libprimesieve
     PUBLIC
@@ -158,10 +167,8 @@
     set_target_properties(libprimesieve-static PROPERTIES OUTPUT_NAME primesieve)
     target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${LIBATOMIC})
 
-    if(BUILD_SHARED_LIBS)
+    if(TARGET libprimesieve)
         add_dependencies(libprimesieve-static libprimesieve)
-    else()
-        add_library(primesieve::primesieve ALIAS libprimesieve-static)
     endif()
 
     target_compile_features(libprimesieve-static
@@ -183,6 +190,27 @@
             ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
 endif()
 
+# Static or shared linking ###########################################
+
+# On Unix-like OSes we use shared linking against libprimesieve by
+# default mainly because this is required by Linux distributions.
+# On Windows we use static linking by default because the library's
+# path is not encoded into the binary. This means that the binary
+# will only work if the DLL is in the same directory or a directory
+# that is in the PATH environment variable.
+
+if(WIN32 AND TARGET libprimesieve-static)
+    set(STATIC_LINKING ON)
+elseif(NOT TARGET libprimesieve)
+    set(STATIC_LINKING ON)
+endif()
+
+if(STATIC_LINKING)
+    add_library(primesieve::primesieve ALIAS libprimesieve-static)
+else()
+    add_library(primesieve::primesieve ALIAS libprimesieve)
+endif()
+
 # primesieve binary ##################################################
 
 if(BUILD_PRIMESIEVE)
@@ -191,7 +219,7 @@
     target_compile_features(primesieve PRIVATE cxx_auto_type)
     install(TARGETS primesieve DESTINATION ${CMAKE_INSTALL_BINDIR})
 
-    if(BUILD_STATIC_LIBS)
+    if(TARGET libprimesieve-static)
         add_dependencies(primesieve libprimesieve-static)
     endif()
 endif()
@@ -226,13 +254,13 @@
               "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfigVersion.cmake"
         DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")
 
-if(BUILD_SHARED_LIBS)
+if(TARGET libprimesieve)
     install(EXPORT primesieveShared
             NAMESPACE primesieve::
             DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")
 endif()
 
-if(BUILD_STATIC_LIBS)
+if(TARGET libprimesieve-static)
     install(EXPORT primesieveStatic
             NAMESPACE primesieve::
             DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")
